﻿Public Class Form1
    Dim sending As New Collection '未送信データをコネクション毎に保存する
    Dim tcp As New Collection '接続中のコネクションを記録する。

    'ログをとる
    Private Sub addlog(ByVal msg$)
        Dim r%
        Dim i%

        r = ListBox1.Items.Add(msg)
        ListBox1.SelectedIndex = r
        If r > 200 Then
            Do While i < 100
                ListBox1.Items.RemoveAt(0)
                i = i + 1
            Loop

        End If
    End Sub

    'sendingのidの位置にdataを格納する。
    'すでにデータがある場合は、dataを追加する
    Private Sub push_data(ByVal id%, ByRef data() As Byte)
        Dim d() As Byte
        Dim n As Integer
        Dim p As Integer

        If sending.Contains(id.ToString) = True Then
            d = sending.Item(id.ToString)
            sending.Remove(id.ToString)

            p = d.Length
            n = p + data.Length - 1
            If n > 0 Then
                ReDim Preserve d(n)
                Buffer.BlockCopy(data, 0, d, p, data.Length)
                sending.Add(d, id.ToString)
            End If
        Else
            sending.Add(data, id.ToString)
        End If
    End Sub

    '着信した
    Private Sub AxTcpipX1_Accepting(ByVal sender As Object, ByVal e As AxTCPIPXLib._DTcpipEvents_AcceptingEvent) Handles AxTcpipX1.Accepting
        Dim t As New AxTCPIPXLib.AxTcpipX '通信用 TCPIO オブジェクトを新規に用意し、これに通信をさせる
        Dim id%

        '記録用のIDを決める。初期値はソケット番号
        id = e.newSocket
        Do While tcp.Contains(id.ToString) = True
            id = id + 1
        Loop
        addlog("AxTcpipX1_Accepting:" & e.newSocket & " as " & id)

        tcp.Add(t, id.ToString)
        Me.Controls.Add(t) 'コントロールに追加
        t.Name = "AxTcpipX2" & id
        t.Tag = id
        'ハンドラーを設定する
        AddHandler t.Received, AddressOf AxTcpipX2_Received
        AddHandler t.Closed, AddressOf AxTcpipX2_Closed
        AddHandler t.Sent, AddressOf AxTcpipX2_Sent

        '通信用オブジェクトで通信を開始する
        t.Accept(e.newSocket)

    End Sub

    '切断処理
    Private Sub AxTcpipX2_Closed(ByVal sender As Object, ByVal e As System.EventArgs) Handles AxTcpipX2.Closed
        Dim id%

        id = TryCast(sender, AxTCPIPXLib.AxTcpipX).Tag
        If sending.Contains(id.ToString) = True Then
            sending.Remove(id.ToString)
        End If
        addlog("AxTcpipX2_Closed:" & id)
    End Sub

    'データを受信した
    Private Sub AxTcpipX2_Received(ByVal sender As Object, ByVal e As AxTCPIPXLib._DTcpipEvents_ReceivedEvent) Handles AxTcpipX2.Received
        Dim t As AxTCPIPXLib.AxTcpipX
        Dim id%
        Dim d() As Byte

        t = TryCast(sender, AxTCPIPXLib.AxTcpipX)
        id = t.Tag
        d = e.data
        If t.Sendable = True Then
            '受信したデータをそのまま送信する
            t.Send(d)
        Else
            '送信できないので、ためておく。送信可能(sentイベント)になったら送信する。
            push_data(id, d)
        End If
        addlog("AxTcpipX2_Received:" & id & "," & d.Length & "bytes")

    End Sub

    '送信した
    Private Sub AxTcpipX2_Sent(ByVal sender As Object, ByVal e As System.EventArgs) Handles AxTcpipX2.Sent
        Dim t As AxTCPIPXLib.AxTcpipX
        Dim d() As Byte
        Dim id%

        t = TryCast(sender, AxTCPIPXLib.AxTcpipX)
        id = t.Tag

        '未送信データがあれば、ここで送信する
        If sending.Contains(id.ToString) = True Then
            d = sending.Item(id.ToString)
            sending.Remove(id.ToString)
            t.Send(d)
        End If

        addlog("AxTcpipX2_Sent:" & id)

    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Button2.Enabled = False
        Label1.Text = AxTcpipX1.copyright
    End Sub

    '開始ボタン
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Button1.Enabled = False
        Button2.Enabled = True
        'ポート7(echo)で着信を待つ
        AxTcpipX1.Listen(7)
    End Sub

    '中断ボタン
    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim t As AxTCPIPXLib.AxTcpipX

        '新規の着信を受け付けない
        AxTcpipX1.Close()
        '接続中のコネクションを切る
        For Each t In tcp
            t.Close()
            tcp.Remove(t.Tag.ToString)
            addlog("close:" & t.Tag)
        Next
        Button1.Enabled = True
        Button2.Enabled = False

    End Sub
End Class
